Page MenuHomeFreeBSD

ixl(4): Fix potential driver interrupt setup issues and startup crash.
ClosedPublic

Authored by erj on Feb 5 2016, 10:54 PM.

Details

Summary
  • Limit queue autoconfiguration to 8 queues to prevent the driver from requesting a large number of MSI-X vectors at boot.
  • Fix potential kernel panic when loading the driver and the driver cannot setup all requested MSIX vectors. Instead, attach() should exit with a failure code.
    • Move taskqueue setup to later in attach() to prevent having to free taskqueues if another error later in attach() occurs.
Test Plan

-Reboot/attach/init tests using default MSIX vectors.
-Reboot/attach/init tests using user-defined MSIX vectors (not to exceed 184).

Diff Detail

Repository
rS FreeBSD src repository
Lint
Lint OK
Unit
No Unit Test Coverage
Build Status
Buildable 2404
Build 2420: arc lint + arc unit

Event Timeline

erj updated this revision to Diff 13071.Feb 5 2016, 10:54 PM
erj retitled this revision from to ixl(4): Fix potential driver interrupt setup issues and startup crash..
erj updated this object.
erj edited the test plan for this revision. (Show Details)Feb 5 2016, 10:55 PM
erj added a subscriber: jeffrey.e.pieper_intel.com.
jeffrey.e.pieper_intel.com edited the test plan for this revision. (Show Details)Feb 9 2016, 2:23 AM
This revision is now accepted and ready to land.Feb 10 2016, 6:55 PM
erj edited reviewers, added: sbruno; removed: gnn.Feb 19 2016, 11:23 PM
erj added a reviewer: smh.
erj closed this revision.Feb 25 2016, 12:47 AM

Committed in rS295946.